# frozen_string_literal: true

# checker Api::Dmo::HermesController avant d'ajouter des méthodes
module Hermes
  module Api
    module Dmo
      class UpdateSubscriptionsController < Hermes::Api::Dmo::ApplicationController
                
        VALID_OPERATORS = %w[
          $in
          $nin
          $ne
          $gt
          $gte
          $lt
          $lte
          $regex
        ].freeze

        ACCEPTABLE_PARAMS = %w[
          name
          object_id
          email
          web
          slack
          sms
          user_email
        ].freeze

        REGEX_PARAMS = %w[
        ].freeze

        MUTATE_PARAMS = %i[
        ].freeze
        

        def is_admin
          !(current_user_roles & ['Administrator', 'superadministrateur']).empty?
        end 

        def index
          acceptable_params *ACCEPTABLE_PARAMS
          regex_params *REGEX_PARAMS
          valid_operators *VALID_OPERATORS

          aggregation = index_aggregation(no_acl: true).where(reference_model_name: 'User')
          aggregation = aggregation.where(object_id: current_user.id) unless is_admin

          paginate(
            aggregation,
            each_serializer: @serializer,
            **@options
          )
        end
        
      end
    end
  end

end
