# frozen_string_literal: true

class ExecuteSopraTaskJob < ActiveJob::Base
 
  queue_as :exsopralow
  unique :until_executed

  def perform(endpoint, xml, method="post", classname=nil, id=nil, new_hash_xml = nil, type = nil)
    res = 
      if method == 'get'
        Hermes::BoClient::Client.new.send(method, endpoint, {}, classname, id)
      else
        Hermes::BoClient::Client.new.send(method, endpoint, classname, id, xml)
      end
    ExecuteSopraTaskJob.after_response(res.code, res.body, classname, id, new_hash_xml, type) if res
    res
  end

  def self.after_response(code, body, classname, id, new_hash_xml, type)
    if code == 200 && instance = classname.constantize.find(id)
      if new_hash_xml 
        instance.set(
          updated_at: DateTime.current,
          hash_xml: new_hash_xml,
          last_successful_xml_sent_date: Date.today
        )
      end 
      
      case type
      when 'flux_30'
        instance.set(updated_at: DateTime.current, first_flux_30_sended: true)
        Hermes::BoClient::UpdateOrientationTask.new(housing_request_id: instance.id).execute unless instance.updated_orientation_at
      when 'update_orientation'
        instance.update_request_orientation(body)
      end

    end
  end 
end
