module Hermes
  class DisabilityReferent
    include Hermes::Concerns::CommonFieldsConcern
    field :recognized_disability, type: Boolean # handicap reconnu par la Maison départementale des personnes handicapées
    field :near_home, type: Boolean # avez-vous élu domicile auprès de lui
    field :name, type: String # nom
    field :address, type: String # adresse
    field :phone, type: String # telephone
    field :email, type: String # email

    embedded_in :disability, class_name: 'Hermes::Disability'

    common_indexes *%i[
      recognized_disability
      near_home
      name
      address
      phone
      email
    ]
  end
end