def run
  nuds = Hermes::Nud.where({ housing_request: { is_active: true } })
  active_nuds_count = nuds.count

  puts("#{active_nuds_count} active nuds found")

  CSV.open('script_8635_housing_request_unique_numbers_v1.csv', "ab") do |csv|
    csv << ['nud_id', 'housing_request_id', 'unique_numbers_was', 'unique_numbers', 'state']

    nuds.batch_size(5).each_with_index do |nud, idx|
      puts("Start checking #{idx+1}/#{active_nuds_count}")
      row = []
      housing_request = nud.housing_request
      begin
        row.push(nud.id)
        row.push(housing_request.id)
        unique_numbers_was = housing_request.unique_numbers
        row.push(unique_numbers_was)

        nud.update_housing_request_unique_numbers

        row.push(housing_request.reload.unique_numbers)

        if unique_numbers_was.count != housing_request.unique_numbers.count
          diff = unique_numbers_was.count - housing_request.unique_numbers
          puts("#{diff} Unique numbers changed for request #{housing_request.id}")
        end

        csv << row
      rescue => exception
        row.push(nud.id)
        row.push(housing_request.id)
        row.push(nil)
        row.push(housing_request.unique_numbers)
        row.push("error: #{exception.inspect}")
        csv << row
        puts("error while update unique_numbers => #{exception.inspect}")
      end
    end
  end
end

run